libdap::Response Class Reference

`#include <Response.h>`

Inheritance diagram for libdap::Response:

## Public Member Functions

getters
virtual int | get_status () const
virtual FILE * | get_stream () const
virtual std::istream * | get_cpp_stream () const
virtual ObjectType | get_type () const
virtual std::string | get_version () const
virtual std::string | get_protocol () const
setters
virtual void | set_status (int s)
virtual void | set_stream (FILE *s)
virtual void | set_cpp_stream (std::istream *s)
virtual void | set_type (ObjectType o)
virtual void | set_version (const std::string &v)
virtual void | set_protocol (const std::string &p)

## Suppressed default methods

| Response (const Response &)
Response & | operator= (const Response &)
| Response (FILE *s, int status=0)
| Response (std::fstream *s, int status=0)
virtual | ~Response ()

## Detailed Description

Encapsulate a response. Instead of directly returning the FILE pointer from which a response is read, return an instance of this object. For a simple system where all that needs to be done to free the stream and its associated resources, this is overkill. However, some streams may require complex operations to free their resources once the client is done with the stream. Those classes should return a subclass of Response which has those operations built into the destructor.

Todo:
  If the code that parses the MIME headers was moved from Connect and HTTPConnect to this class and its children, it would be easier to build a FileConnect class (or maybe the specifics of the connection type could be held in the Response object and HTTPConnect and the to-be-written FileConnect would not be needed).

Definition at line 52 of file Response.h.

## Constructor & Destructor Documentation

## Response() [1/3]

libdap::Response::Response | ( |  | ) |

inline

Definition at line 75 of file Response.h.

## Response() [2/3]

libdap::Response::Response | ( | FILE * | s,
|  | int | status = `0`
| ) |  |

inline

Initialize with a stream. Create an instance initialized to a stream. by default get_type() and get_version() return default values of unknown_type and "dods/0.0", respectively. Specializations (see HTTPResponse and HTTPConnect) may fill these fields in with other values.

Parameters

  s | Read data from this stream.
  status | The HTTP response status code.

Definition at line 85 of file Response.h.

## Response() [3/3]

libdap::Response::Response | ( | std::fstream * | s,
|  | int | status = `0`
| ) |  |

inline

Definition at line 89 of file Response.h.

## ~Response()

virtual libdap::Response::~Response | ( |  | ) |

inline virtual

Close the stream.

Definition at line 94 of file Response.h.

## Member Function Documentation

## get_cpp_stream()

virtual std::istream * libdap::Response::get_cpp_stream | ( |  | ) | const

inline virtual

Definition at line 105 of file Response.h.

## get_protocol()

virtual std::string libdap::Response::get_protocol | ( |  | ) | const

inline virtual

Definition at line 109 of file Response.h.

## get_status()

virtual int libdap::Response::get_status | ( |  | ) | const

inline virtual

Definition at line 103 of file Response.h.

## get_stream()

virtual FILE * libdap::Response::get_stream | ( |  | ) | const

inline virtual

Definition at line 104 of file Response.h.

## get_type()

virtual ObjectType libdap::Response::get_type | ( |  | ) | const

inline virtual

Definition at line 107 of file Response.h.

## get_version()

virtual std::string libdap::Response::get_version | ( |  | ) | const

inline virtual

Definition at line 108 of file Response.h.

## set_cpp_stream()

virtual void libdap::Response::set_cpp_stream | ( | std::istream * | s | ) |

inline virtual

Definition at line 117 of file Response.h.

## set_protocol()

virtual void libdap::Response::set_protocol | ( | const std::string & | p | ) |

inline virtual

Definition at line 121 of file Response.h.

## set_status()

virtual void libdap::Response::set_status | ( | int | s | ) |

inline virtual

Definition at line 114 of file Response.h.

## set_stream()

virtual void libdap::Response::set_stream | ( | FILE * | s | ) |

inline virtual

Definition at line 116 of file Response.h.

## set_type()

virtual void libdap::Response::set_type | ( | ObjectType | o | ) |

inline virtual

Definition at line 119 of file Response.h.

## set_version()

virtual void libdap::Response::set_version | ( | const std::string & | v | ) |

inline virtual

Definition at line 120 of file Response.h.

The documentation for this class was generated from the following file:

- Response.h